"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _tsUtils = require("./tsUtils");

var _default = (0, _tsUtils.createRule)({
  name: __filename,
  meta: {
    docs: {
      category: 'Best Practices',
      description: 'Suggest using toStrictEqual()',
      recommended: false
    },
    messages: {
      useToStrictEqual: 'Use toStrictEqual() instead'
    },
    fixable: 'code',
    type: 'suggestion',
    schema: []
  },
  defaultOptions: [],

  create(context) {
    return {
      CallExpression(node) {
        if (!(0, _tsUtils.isExpectCall)(node)) {
          return;
        }

        const _parseExpectCall = (0, _tsUtils.parseExpectCall)(node),
              matcher = _parseExpectCall.matcher;

        if (matcher && matcher.name === 'toEqual') {
          context.report({
            fix: fixer => [fixer.replaceText(matcher.node.property, 'toStrictEqual')],
            messageId: 'useToStrictEqual',
            node: matcher.node.property
          });
        }
      }

    };
  }

});

exports.default = _default;